#include <stdlib.h>

#include "SC_PlugIn.h"

static InterfaceTable *ft;
struct ProbSwitch : public Unit
{
};

extern "C"
{
	void load(InterfaceTable *inTable);
        void ProbSwitch_next_a(ProbSwitch *unit, int inNumSamples);
	void ProbSwitch_Ctor(ProbSwitch* unit);
};

void ProbSwitch_Ctor(ProbSwitch* unit) {
  float prob = IN0(1);
  SETCALC(ProbSwitch_next_a);
  printf("rand: %f", rand() / (RAND_MAX * 1.0));
}


void ProbSwitch_next_a(ProbSwitch *unit, int inNumSamples) {
	float *out = OUT(0);
	float *in = IN(0);
	float prob = IN0(1);
	
	for (int i=0; i < inNumSamples; ++i) {
	  if ((rand() / (RAND_MAX * 1.0)) >= prob) {
	    out[i] = in[i];
	  }
	  else {
	    // negate
	    out[i] = 0 - in[i];
	  }
	}
}

void load(InterfaceTable *inTable) {
	ft = inTable;
	DefineSimpleUnit(ProbSwitch);
}
